/*----------------------------------------------------------------*/
/* SDJ[hǂݍ݃Cu              (C)KAMAI(TOPOZO), 2010 */
/*----------------------------------------------------------------*/

#include "sd.h"

/*------------------------------------*/
/* vg^Cv錾                   */
/*------------------------------------*/
static uint8_t spi_inout(uint8_t d);
static uint8_t sd_send_cmd(uint8_t cmd, unsigned long data, uint8_t crc);

/*------------------------------------*/
/* ֐Fsd_init                    */
/* ߂lFG[R[h(0Ȃ琳I)*/
/* FubNEtOւ̃|C^ */
/* @\FSDJ[h̏s   */
/*------------------------------------*/
uint8_t sd_init(uint8_t* const block_flg)
{
	uint16_t cnt;		// MJE^
	uint8_t	res,		// X|X
			type = 0;	// ށF0:MMC 1:SD1 2:SD2
	/* SPI */
	DDRB |= _BV(SCK) | _BV(MOSI) | _BV(SS);
	SPCR = _BV(SPE) | _BV(MSTR) | _BV(SPR1);	// Mode0
	SPSR = _BV(SPI2X); 							// 1/32 (250kHz)
	/* R}ht */
	SS_H();
	for(cnt = 10 ; cnt ; cnt--) spi_inout(0xff);
	/* _~[EEFCg */
	SS_L();
	for(cnt = 1000 ; cnt ; cnt--) spi_inout(0xff);
	/* \tgEFAEZbg */
	res = sd_send_cmd(0, 0, 0x4a);
	if(res == 0x01){
		/* SDCv2 */
		if(sd_send_cmd(8, 0x1aa, 0x43) < 2) type = 2;
		/*  */
		if(type != 2 || ((spi_inout(0xff) << 8) | spi_inout(0xff)) == 0x1aa){
			if(type != 2 && sd_send_cmd(55, 0, 0) < 2 && sd_send_cmd(41, 0, 0) < 2) type = 1;
			cnt = 10000;
			do{
				res = type ? sd_send_cmd(55, 0, 0) : 0x00;
				if(res < 2) res = sd_send_cmd(type ? 41 : 1, (type == 2) ? 1UL << 30 : 0, 0);
			}while(res && --cnt);
			/* ݒ */
			if(res == 0x00){
				/* ubNEAhbVO */
				res = sd_send_cmd(58, 0, 0);
				*block_flg = (spi_inout(0xff) & 0x40) ? 1 : 0;
				spi_inout(0xff); spi_inout(0xff); spi_inout(0xff);
				if(res == 0x00 && *block_flg == 0) res = sd_send_cmd(16, 512, 0); // ubNZbg
			}
		}
		else res = 0x81;
	}
	else if(res == 0x00) res = 0x80;
	SS_H();
	/* NbNύX */
	SPCR &= ~_BV(SPR1);	// 1/2(4Mhz)
	return res;
}

/*------------------------------------*/
/* ֐Fsd_read                    */
/* ߂lFG[R[h(0Ȃ琳I)*/
/* FAhX                     */
/* f[^E|C^                   */
/* ItZbg                         */
/* ǍoCg                       */
/* @\FSDJ[h̓ǂݍ݂s     */
/*------------------------------------*/
uint8_t sd_read(unsigned long address, uint8_t buf[], uint16_t offset, uint16_t count)
{
	register uint16_t cnt;	// JE^
	uint8_t res;			// X|X

	/* VOEubNE[h */
	res = sd_send_cmd(17, address, 0);
	if(res == 0x00){
		/* f[^EX^[g(0xFE)܂̓G[EX|X */
		for(cnt = 10000 ; cnt && ((res = spi_inout(0xff)) == 0xff) ; cnt--);
		if(res == 0xfe){
			res = 0x00;
			/* f[^i[ */
			for(cnt = offset ; cnt ; cnt--) spi_inout(0xff);					// ItZbgړ
			for(; cnt < count ; cnt++) buf[cnt] = spi_inout(0xff);			// woCgǍ
			for(cnt = 512 - offset - count ; cnt ; cnt--) spi_inout(0xff);	// cړ
			spi_inout(0xff); spi_inout(0xff);									// CRCǂݍ
		}
	}
	SS_H();
	return res;
}

/*------------------------------------*/
/* ֐Fspi_inout                  */
/* ߂lFMf[^                 */
/* FMf[^                   */
/* @\FSPIŃf[^̑Ms    */
/*------------------------------------*/
static uint8_t spi_inout(uint8_t d)
{
	SPDR = d;
	while(!(SPSR & _BV(SPIF)));
	return SPDR;
}

/*------------------------------------*/
/* ֐Fsd_send_cmd                */
/* ߂lFX|X                 */
/* FR}h                     */
/* f[^                             */
/* @\FR}h𑗐M           */
/*------------------------------------*/
static uint8_t sd_send_cmd(uint8_t cmd, unsigned long data, uint8_t crc)
{
	uint8_t res; //X|X
	int8_t i;
	
	/* _~[NbN, L*/
	SS_H(); spi_inout(0xff); SS_L();
	/* X^[gErbg,R}h*/
	spi_inout(0x40 | cmd);
	/* f[^*/
	for(i = 24 ; i >= 0 ; i -= 8) spi_inout(data >> i);
	/* CRC,XgbvErbg*/
	spi_inout((crc << 1) | 0x01);
	/* X|X*/
	for(i = 0 ; ((res = spi_inout(0xff)) & 0x80) && i < 8 ; i++);
	return res;
}
